import { ref } from 'vue'

import type { Subscriptions, WorkflowRunResult } from './models'
import { useData, type DataStoreType } from "@/stores/data"

export const subscriptions = ref<Subscriptions>({ wfs: {} })

let data: DataStoreType

async function onSocketMessage(msg: MessageEvent) {
    const wfRunResult: WorkflowRunResult = JSON.parse(msg.data)
    data.addRun(wfRunResult)
}

export function initWebsocket(apiUrl: string) {
    data = useData()
    ws = new WebSocket(apiUrl + "/ws")
    //ws.onopen    = onSocketOpen
    ws.onmessage = onSocketMessage
    //ws.onerror   = onSocketError
}

export async function subscribeWf(wfId: string) {
}

let ws: WebSocket